//+------------------------------------------------------------------+
//|                                                      GridBag.mqh |
//|                        Copyright 2018, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict
#define protected public
#include <Canvas\Canvas.mqh>
#undef protected

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
class CGridBug
  {
private:
public:
   CCanvas           C;
                     CGridBug();
                    ~CGridBug();
   void              ReDraw();
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CGridBug::CGridBug()
  {
   int Width=(ushort)ChartGetInteger(0,CHART_WIDTH_IN_PIXELS);                               // get Window width
   int Height;
   if(Width>1920)
     {
      Width=3840;
      Height=2160;
     }
   else
     {
      Width=1920;
      Height=1080;
     }
   if(!C.CreateBitmapLabel(0,0,"GridBug",0,0,Width,Height,COLOR_FORMAT_ARGB_NORMALIZE)) // create canvas with the size of the current window
      Print("Error creating canvas: ",GetLastError());
   ReDraw();
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
CGridBug::~CGridBug()
  {
   C.Destroy();
  }
//+------------------------------------------------------------------+
void CGridBug::ReDraw()
  {
   C.Erase(0);
   if(ChartGetInteger(0,CHART_SHOW_GRID))
     {
      ObjectSetInteger(C.m_chart_id,C.m_objname,OBJPROP_BACK,false);
      ChartSetInteger(0,CHART_FOREGROUND,0,true);
      uint clr = ColorToARGB((color)ChartGetInteger(0,CHART_COLOR_GRID),255);
      for(int y=0; y<C.m_height; y++)
         if(y%6<2 || y%6>4)
           {
            for(int x=32; x<C.m_width; x+=32)
               C.m_pixels[y*C.m_width+x]=clr;
           }
     }
   C.Update();
  }
//+------------------------------------------------------------------+
CGridBug grid_bug;